/******************************************************************************
* Copyright Kylin Software  Co, Ltd.(c) (2020)
* FileName: tuple_queue.h
* Version:  1.0
* Function Description:
*		Declares the five-tuple queue operation functions
*
* History:
*    <author>     <time>      <version>    <desc>
*    wangshengye  2023/5/19    1.0         Initial build
********************************************************************************/
#ifndef _TUPLE_QUEUE_H_
#define _TUPLE_QUEUE_H_

#include <linux/wait.h>
#include "common.h"

/* 
 * Define the elements in the queue
 */
struct tuple_data {
	struct pkt_addr_info tuple;
	struct list_head list;
};

/*
 * Define the queue,contains a wait queue header
 */
struct tuple_queue {
	struct list_head head;
	int len;
	spinlock_t lock;
	wait_queue_head_t wait;
};

extern int kthread_handler_policy_exit;

/* Declares a queue */
extern struct tuple_queue queue;
/* Five-tuple queue initial */
void tuple_queue_init(void);
/* Put the five-tuple data in the queue */
int tuple_enqueue(struct tuple_data *data);
/* Destroy the queue */
void tuple_queue_destroy(void);
/* Update the policy cache hash table */
int updata_htable_cache(void *arg);

#endif /*_TUPLE_QUEUE_H_*/
